uses crt, dos;

type
  MSGTOIDXrecord = String[35];

  LASTCALLrecord = record
                     Line           : Byte;
                     Name,
                     Handle         : MSGTOIDXrecord;
                     City           : String[25];
                     Baud           : Word;
                     Times          : LongInt;
                     LogOn          : String[5];
                     LogOff         : String[5];
                     Attribute      : Byte;
                   end;

                { Attribute - Bit 0 : Hidden }

var  lcfile : file of LASTCALLrecord;
     lcrec : LASTCALLrecord;
     count : INTEGER;
     lcpath : STRING[128];
     handles : BOOLEAN;

procedure header;
begin       {012345678901234567890123456789012345678901234567890123456789012345}
     textcolor (15);
     writeln('         UserName      Line  LogOn  LogOff   Speed          Location        ');
     textcolor (4);
     writeln('   Ĵ');
     textcolor (7);
end;        {0         1         2         3         4         5         6}

procedure enter;
begin
     textcolor (7);
     write ('Press ');
     textcolor (14);
     write ('[');
     textcolor (15);
     write ('ENTER');
     textcolor (14);
     write (']');
     textcolor (7);
     write (' to continue...');
     readln;
end;

procedure usage;
begin
     clrscr;
     writeln ('USAGE:');
     writeln ('  LIST <Path to LASTCALL.BBS> [/H]');
     writeln ('  /H - Display handles instead of real names');
     writeln;
     writeln ('Switches in []''s are optional');
     halt (10);
end;

begin
     count := 3;
     if (paramcount = 0) then
     begin
          usage;
     end
     else if (paramcount > 2) then
     begin
          usage;
     end
     else
     begin
          lcpath := paramstr(1);
          lcpath := (lcpath + '\LASTCALL.BBS');
          for count := 0 to length(lcpath) do
          begin
               lcpath[count] := upcase(lcpath[count]);
          end;
          count := 0;
          if (paramstr(2) = '/H') or (paramstr(2) = '/h') then handles := TRUE else handles := FALSE;
          textbackground (0);
          clrscr;
          assign (lcfile, lcpath);
          {$I-}
          reset (lcfile);
          {$I+}
          case IORESULT of
               3 : begin
                        clrscr;
                        writeln ('Path not found - ',lcpath);
                        halt (11);
                   end;
               5 : begin
                        clrscr;
                        writeln ('LASTCALL.BBS Not Found');
                        halt (12);
                   end;
          end;
          header;
          count := 3;
          with lcrec do
          begin
               while not eof(lcfile) do
               begin
                    read (lcfile, lcrec);
                    if (Handles = FALSE) then
                    begin
                         gotoxy(6,count);
                         write(name);
                    end
                    else
                    begin
                         gotoxy(6,count);
                         write (handle);
                    end;
                    gotoxy(26,count);
                    write (line);
                    gotoxy(30,count);
                    write (LogOn);
                    gotoxy(38,count);
                    write (LogOff);
                    gotoxy(46,count);
                    write (baud);
                    gotoxy(54,count);
                    writeln (City);
                    count := count+1;
                    if (count > 23) then
                    begin
                         writeln;
                         enter;
                         count := 3;
                         clrscr;
                         header;
                    end;
               end;
               writeln;
               enter;
          end;
     end;
end.